Index: src/Filling/unittests/IsVoidNode_FillPredicateUnitTest.cpp
===================================================================
--- src/Filling/unittests/IsVoidNode_FillPredicateUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/unittests/IsVoidNode_FillPredicateUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,126 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * IsVoidNode_FillPredicateUnitTest.cpp
+ *
+ *  Created on: Jan 18, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include <algorithm>
+#include <boost/bind.hpp>
+#include <iostream>
+
+#include "CodePatterns/Assert.hpp"
+
+#include "Atom/atom.hpp"
+#include "Box.hpp"
+#include "Filling/Predicates/IsVoidNode_FillPredicate.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+#include "Filling/NodeTypes.hpp"
+#include "Shapes/BaseShapes.hpp"
+#include "Shapes/Shape.hpp"
+#include "World.hpp"
+
+#include "IsVoidNode_FillPredicateUnitTest.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( IsVoidNode_FillPredicateTest );
+
+void DoSomething(atom * const _atom)
+{
+  _atom->setPosition( Vector((double)_atom->getId(), 0., 0.) );
+}
+
+void IsVoidNode_FillPredicateTest::setUp()
+{
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+
+  // set default BCs to ignore
+  World::getInstance().getDomain().setConditions(
+      BoundaryConditions::Conditions_t(3, BoundaryConditions::Ignore)
+  );
+
+  // create some atoms as "neighbours"
+  atoms.resize((size_t)5, NULL);
+  std::generate_n(atoms.begin(), (size_t)5, boost::bind(&World::createAtom, World::getPointer()) );
+
+  // position them
+  std::for_each(atoms.begin(), atoms.end(), &DoSomething);
+
+  predicate = new FillPredicate(IsVoidNode_FillPredicate(Sphere()));
+}
+
+
+void IsVoidNode_FillPredicateTest::tearDown()
+{
+  delete predicate;
+
+  World::purgeInstance();
+}
+
+/** Test whether operator() returns as desired
+ *
+ */
+void IsVoidNode_FillPredicateTest::operatorTest()
+{
+#ifndef NDEBUG
+  std::cout << "The following Assertion is intended and does not represent a failure of the test." << std::endl;
+  CPPUNIT_ASSERT_THROW( (*predicate)( Vector(-2.,0.,0.)), Assert::AssertionFailure );
+#else
+  CPPUNIT_ASSERT( (*predicate)( Vector(-2.,0.,0.)) );
+#endif
+  for (double i = 0; i < 5.; ++i) {
+    CPPUNIT_ASSERT( !(*predicate)( Vector(i, 0., 0.)) );
+    CPPUNIT_ASSERT( !(*predicate)( Vector(i, 1., 0.)) );
+#ifndef NDEBUG
+  std::cout << "The following Assertion is intended and does not represent a failure of the test." << std::endl;
+  CPPUNIT_ASSERT_THROW( (*predicate)( Vector(i, -1., 0.)), Assert::AssertionFailure );
+#else
+  CPPUNIT_ASSERT( !(*predicate)( Vector(i, -1., 0.)) );
+#endif
+    CPPUNIT_ASSERT( !(*predicate)( Vector(i, 0., 1.)) );
+#ifndef NDEBUG
+  std::cout << "The following Assertion is intended and does not represent a failure of the test." << std::endl;
+  CPPUNIT_ASSERT_THROW( (*predicate)( Vector(i, 0., -1.)), Assert::AssertionFailure );
+#else
+  CPPUNIT_ASSERT( !(*predicate)( Vector(i, 0., -1.)) );
+#endif
+  }
+  CPPUNIT_ASSERT( (*predicate)( Vector(5.,1.,0.)) );
+#ifndef NDEBUG
+  std::cout << "The following Assertion is intended and does not represent a failure of the test." << std::endl;
+  CPPUNIT_ASSERT_THROW(  (*predicate)( Vector(5.,-1.,0.)), Assert::AssertionFailure );
+#else
+  CPPUNIT_ASSERT( (*predicate)( Vector(5.,-1.,0.)) );
+#endif
+  CPPUNIT_ASSERT( (*predicate)( Vector(5.,0.,1.)) );
+#ifndef NDEBUG
+  std::cout << "The following Assertion is intended and does not represent a failure of the test." << std::endl;
+  CPPUNIT_ASSERT_THROW( (*predicate)( Vector(5.,0.,-1.)), Assert::AssertionFailure );
+#else
+  CPPUNIT_ASSERT( (*predicate)( Vector(5.,0.,-1.)) );
+#endif
+  CPPUNIT_ASSERT( (*predicate)( Vector(6.,0.,0.)) );
+}
Index: src/Filling/unittests/IsVoidNode_FillPredicateUnitTest.hpp
===================================================================
--- src/Filling/unittests/IsVoidNode_FillPredicateUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/unittests/IsVoidNode_FillPredicateUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,42 @@
+/*
+ * IsVoidNode_FillPredicateUnitTest.hpp
+ *
+ *  Created on: Jan 18, 2012
+ *      Author: heber
+ */
+
+#ifndef ISVOIDNODE_FILLPREDICATEUNITTEST_HPP_
+#define ISVOIDNODE_FILLPREDICATEUNITTEST_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <cppunit/extensions/HelperMacros.h>
+
+#include <vector>
+
+class atom;
+class FillPredicate;
+
+/********************************************** Test classes **************************************/
+
+class IsVoidNode_FillPredicateTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( IsVoidNode_FillPredicateTest) ;
+    CPPUNIT_TEST ( operatorTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+      void operatorTest();
+
+private:
+      std::vector<atom *> atoms;
+      FillPredicate *predicate;
+};
+
+#endif /* ISVOIDNODE_FILLPREDICATEUNITTEST_HPP_ */
Index: src/Filling/unittests/Makefile.am
===================================================================
--- src/Filling/unittests/Makefile.am	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/unittests/Makefile.am	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,115 @@
+# PLEASE adhere to the alphabetical ordering in this Makefile!
+# Also indentation by a single tab
+
+FILLINGTESTSSOURCES = \
+  ../Filling/unittests/ClusterUnitTest.cpp \
+  ../Filling/unittests/FillerUnitTest.cpp \
+  ../Filling/unittests/IsInsideDomain_FillPredicateUnitTest.cpp \
+  ../Filling/unittests/IsInsideSurface_FillPredicateUnitTest.cpp \
+  ../Filling/unittests/IsValidInDomain_FillPredicateUnitTest.cpp \
+  ../Filling/unittests/IsVoidNode_FillPredicateUnitTest.cpp \
+  ../Filling/unittests/Ops_FillPredicateUnitTest.cpp
+
+FILLINGTESTSHEADERS = \
+  ../Filling/unittests/ClusterUnitTest.hpp \
+  ../Filling/unittests/FillerUnitTest.hpp \
+  ../Filling/unittests/IsInsideDomain_FillPredicateUnitTest.hpp \
+  ../Filling/unittests/IsInsideSurface_FillPredicateUnitTest.hpp \
+  ../Filling/unittests/IsValidInDomain_FillPredicateUnitTest.hpp \
+  ../Filling/unittests/IsVoidNode_FillPredicateUnitTest.hpp \
+  ../Filling/unittests/Ops_FillPredicateUnitTest.hpp
+
+FILLINGTESTS = \
+  ClusterUnitTest \
+  FillerUnitTest \
+  IsInsideDomain_FillPredicateUnitTest \
+  IsInsideSurface_FillPredicateUnitTest \
+  IsValidInDomain_FillPredicateUnitTest \
+  IsVoidNode_FillPredicateUnitTest \
+  Ops_FillPredicateUnitTest
+  
+TESTS += $(FILLINGTESTS)
+check_PROGRAMS += $(FILLINGTESTS) 
+noinst_PROGRAMS += $(FILLINGTESTS)
+
+FILLINGLIBS =
+
+ClusterUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	../Filling/unittests/ClusterUnitTest.cpp \
+	../Filling/unittests/ClusterUnitTest.hpp
+ClusterUnitTest_LDADD = \
+	../libMolecuilderFilling.la \
+	../libMolecuilderUI.la \
+	../libMolecuilder.la \
+	$(top_builddir)/LinearAlgebra/src/LinearAlgebra/libLinearAlgebra.la \
+	${CodePatterns_LIBS} \
+	$(BOOST_LIBS)
+
+FillerUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	../Filling/unittests/FillerUnitTest.cpp \
+	../Filling/unittests/FillerUnitTest.hpp
+FillerUnitTest_LDADD = \
+	../libMolecuilderFilling.la \
+	../libMolecuilderUI.la \
+	../libMolecuilder.la \
+	$(top_builddir)/LinearAlgebra/src/LinearAlgebra/libLinearAlgebra.la \
+	${CodePatterns_LIBS} \
+	$(BOOST_LIBS)
+
+IsInsideDomain_FillPredicateUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	../Filling/unittests/IsInsideDomain_FillPredicateUnitTest.cpp \
+	../Filling/unittests/IsInsideDomain_FillPredicateUnitTest.hpp
+IsInsideDomain_FillPredicateUnitTest_LDADD = \
+	../libMolecuilderFilling.la \
+	../libMolecuilderUI.la \
+	../libMolecuilder.la \
+	$(top_builddir)/LinearAlgebra/src/LinearAlgebra/libLinearAlgebra.la \
+	${CodePatterns_LIBS} \
+	$(BOOST_LIBS)
+
+IsInsideSurface_FillPredicateUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	../Filling/unittests/IsInsideSurface_FillPredicateUnitTest.cpp \
+	../Filling/unittests/IsInsideSurface_FillPredicateUnitTest.hpp
+IsInsideSurface_FillPredicateUnitTest_LDADD = \
+	../libMolecuilderFilling.la \
+	../libMolecuilderUI.la \
+	../libMolecuilder.la \
+	$(top_builddir)/LinearAlgebra/src/LinearAlgebra/libLinearAlgebra.la \
+	${CodePatterns_LIBS} \
+	$(BOOST_LIBS)
+
+IsValidInDomain_FillPredicateUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	../Filling/unittests/IsValidInDomain_FillPredicateUnitTest.cpp \
+	../Filling/unittests/IsValidInDomain_FillPredicateUnitTest.hpp
+IsValidInDomain_FillPredicateUnitTest_LDADD = \
+	../libMolecuilderFilling.la \
+	../libMolecuilderUI.la \
+	../libMolecuilder.la \
+	$(top_builddir)/LinearAlgebra/src/LinearAlgebra/libLinearAlgebra.la \
+	${CodePatterns_LIBS} \
+	$(BOOST_LIBS)
+
+IsVoidNode_FillPredicateUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	../Filling/unittests/IsVoidNode_FillPredicateUnitTest.cpp \
+	../Filling/unittests/IsVoidNode_FillPredicateUnitTest.hpp
+IsVoidNode_FillPredicateUnitTest_LDADD = \
+	../libMolecuilderFilling.la \
+	../libMolecuilderUI.la \
+	../libMolecuilder.la \
+	$(top_builddir)/LinearAlgebra/src/LinearAlgebra/libLinearAlgebra.la \
+	${CodePatterns_LIBS} \
+	$(BOOST_LIBS)
+
+Ops_FillPredicateUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	../Filling/unittests/Ops_FillPredicateUnitTest.cpp \
+	../Filling/unittests/Ops_FillPredicateUnitTest.hpp
+Ops_FillPredicateUnitTest_LDADD = \
+	../libMolecuilderFilling.la \
+	../libMolecuilderUI.la \
+	../libMolecuilder.la \
+	$(top_builddir)/LinearAlgebra/src/LinearAlgebra/libLinearAlgebra.la \
+	${CodePatterns_LIBS} \
+	$(BOOST_LIBS)
+
+
+#AUTOMAKE_OPTIONS = parallel-tests
Index: src/Filling/unittests/Ops_FillPredicateUnitTest.cpp
===================================================================
--- src/Filling/unittests/Ops_FillPredicateUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/unittests/Ops_FillPredicateUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,272 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * Ops_FillPredicateUnitTest.cpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "CodePatterns/Assert.hpp"
+
+#include "Atom/atom.hpp"
+#include "Box.hpp"
+#include "Filling/Predicates/IsValidInDomain_FillPredicate.hpp"
+#include "Filling/Predicates/IsVoidNode_FillPredicate.hpp"
+#include "Filling/Predicates/Ops_FillPredicate.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+#include "Filling/NodeTypes.hpp"
+#include "Shapes/BaseShapes.hpp"
+#include "World.hpp"
+
+#include "Ops_FillPredicateUnitTest.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( Ops_FillPredicateTest );
+
+void DoSomething(atom * const _atom)
+{
+  _atom->setPosition( Vector((double)_atom->getId(), 0., 0.) );
+}
+
+void Ops_FillPredicateTest::setUp()
+{
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+
+  // set default BCs to ignore
+  World::getInstance().getDomain().setConditions(
+      BoundaryConditions::Conditions_t(3, BoundaryConditions::Ignore)
+  );
+
+  Domainpredicate = new FillPredicate(IsValidInDomain_FillPredicate(World::getInstance().getDomain()));
+
+  // create some atoms as "neighbours"
+  atoms.resize((size_t)5, NULL);
+  std::generate_n(atoms.begin(), (size_t)5, boost::bind(&World::createAtom, World::getPointer()) );
+
+  // position them
+  std::for_each(atoms.begin(), atoms.end(), &DoSomething);
+
+  Voidpredicate = new FillPredicate(IsVoidNode_FillPredicate(Sphere()));
+}
+
+
+void Ops_FillPredicateTest::tearDown()
+{
+  delete Domainpredicate;
+  delete Voidpredicate;
+
+  World::purgeInstance();
+}
+
+/** Test whether operator() returns as desired
+ *
+ */
+void Ops_FillPredicateTest::AndTest()
+{
+	FillPredicate Andpredicate = (*Domainpredicate) && (*Voidpredicate);
+
+	CPPUNIT_ASSERT( !Andpredicate( Vector(-1.,1.,0.)) );
+  CPPUNIT_ASSERT( !Andpredicate( Vector(-2.,0.,0.)) );
+	CPPUNIT_ASSERT( Andpredicate( Vector(5.,1.,0.)) );
+  CPPUNIT_ASSERT( Andpredicate( Vector(5.,0.,1.)) );
+  for (double i = 0; i < 5.; ++i) {
+    CPPUNIT_ASSERT( !Andpredicate( Vector(i, 0., 0.)) );
+    CPPUNIT_ASSERT( !Andpredicate( Vector(i, 1., 0.)) );
+    CPPUNIT_ASSERT( !Andpredicate( Vector(i, -1., 0.)) );
+    CPPUNIT_ASSERT( !Andpredicate( Vector(i, 0., 1.)) );
+    CPPUNIT_ASSERT( !Andpredicate( Vector(i, 0., -1.)) );
+  }
+  CPPUNIT_ASSERT( !Andpredicate( Vector(5.,-1.,0.)) );
+  CPPUNIT_ASSERT( Andpredicate( Vector(5.,0.,1.)) );
+  CPPUNIT_ASSERT( !Andpredicate( Vector(5.,0.,-1.)) );
+  CPPUNIT_ASSERT( Andpredicate( Vector(6.,0.,0.)) );
+}
+/** Test whether operator() returns as desired
+ *
+ */
+void Ops_FillPredicateTest::OrTest()
+{
+  FillPredicate Orpredicate = (*Domainpredicate) || (*Voidpredicate);
+
+  // in OR case: Voidpredicate will always throw because it internally checks
+  // whether Linked Cell structure gets correct index to cell, which fails under
+  // Ignore boundary conditions
+#ifndef NDEBUG
+  std::cout << "The following Assertion is intended and does not represent a failure of the test." << std::endl;
+  CPPUNIT_ASSERT_THROW( Orpredicate( Vector(-1.,1.,0.)), Assert::AssertionFailure );
+#else
+  CPPUNIT_ASSERT( Orpredicate( Vector(-1.,1.,0.)) );
+#endif
+	CPPUNIT_ASSERT( Orpredicate( Vector(5.,1.,0.)) );
+#ifndef NDEBUG
+  std::cout << "The following Assertion is intended and does not represent a failure of the test." << std::endl;
+  CPPUNIT_ASSERT_THROW( Orpredicate( Vector(-2.,0.,0.)), Assert::AssertionFailure );
+#else
+  CPPUNIT_ASSERT( Orpredicate( Vector(-2.,0.,0.)) );
+#endif
+  for (double i = 0; i < 5.; ++i) {
+    CPPUNIT_ASSERT( Orpredicate( Vector(i, 0., 0.)) );
+    CPPUNIT_ASSERT( Orpredicate( Vector(i, 1., 0.)) );
+#ifndef NDEBUG
+  std::cout << "The following Assertion is intended and does not represent a failure of the test." << std::endl;
+  CPPUNIT_ASSERT_THROW( Orpredicate( Vector(i, -1., 0.)), Assert::AssertionFailure );
+#else
+  CPPUNIT_ASSERT( !Orpredicate( Vector(i, -1., 0.)) );
+#endif
+    CPPUNIT_ASSERT( Orpredicate( Vector(i, 0., 1.)) );
+#ifndef NDEBUG
+  std::cout << "The following Assertion is intended and does not represent a failure of the test." << std::endl;
+  CPPUNIT_ASSERT_THROW( Orpredicate( Vector(i, 0., -1.)), Assert::AssertionFailure );
+#else
+  CPPUNIT_ASSERT( !Orpredicate( Vector(i, 0., -1.)) );
+#endif
+  }
+  CPPUNIT_ASSERT( Orpredicate( Vector(5.,1.,0.)) );
+#ifndef NDEBUG
+  std::cout << "The following Assertion is intended and does not represent a failure of the test." << std::endl;
+  CPPUNIT_ASSERT_THROW( Orpredicate( Vector(5.,-1.,0.)), Assert::AssertionFailure );
+#else
+  CPPUNIT_ASSERT( Orpredicate( Vector(5.,-1.,0.)) );
+#endif
+  CPPUNIT_ASSERT( Orpredicate( Vector(5.,0.,1.)) );
+#ifndef NDEBUG
+  std::cout << "The following Assertion is intended and does not represent a failure of the test." << std::endl;
+  CPPUNIT_ASSERT_THROW( Orpredicate( Vector(5.,0.,-1.)), Assert::AssertionFailure );
+#else
+  CPPUNIT_ASSERT( Orpredicate( Vector(5.,0.,-1.)) );
+#endif
+  CPPUNIT_ASSERT( Orpredicate( Vector(6.,0.,0.)) );
+}
+
+/** Test whether operator!() returns as desired
+ *
+ */
+void Ops_FillPredicateTest::NotTest()
+{
+  Box &domain = World::getInstance().getDomain();
+  Node origin(0.,0.,0.);
+  Node center(10.,10.,10.);
+  Node corner(20.,20.,20.);
+  Node outside(30.,30.,30.);
+
+  FillPredicate Notpredicate = !(*Domainpredicate);
+  FillPredicate Notpredicate2 = !(*Voidpredicate);
+
+  domain.setConditions(
+      BoundaryConditions::Conditions_t(3, BoundaryConditions::Wrap)
+  );
+  // boundary conditions: Wrap
+  {
+    // origin is inside
+    CPPUNIT_ASSERT( !Notpredicate(origin) );
+
+    // center is inside
+    CPPUNIT_ASSERT( !Notpredicate(center) );
+
+    // corner is inside
+    CPPUNIT_ASSERT( !Notpredicate(corner) );
+
+    // outside is outside
+    CPPUNIT_ASSERT( !Notpredicate(outside) );
+  }
+
+  // boundary conditions: Bounce
+  {
+    domain.setCondition(0, BoundaryConditions::Bounce);
+    // origin is inside
+    CPPUNIT_ASSERT( !Notpredicate(origin) );
+
+    // center is inside
+    CPPUNIT_ASSERT( !Notpredicate(center) );
+
+    // corner is inside
+    CPPUNIT_ASSERT( !Notpredicate(corner) );
+
+    // outside is outside
+    CPPUNIT_ASSERT( !Notpredicate(outside) );
+    domain.setCondition(0, BoundaryConditions::Wrap);
+  }
+
+  // boundary conditions: Ignore
+  {
+    domain.setCondition(0, BoundaryConditions::Ignore);
+    // origin is inside
+    CPPUNIT_ASSERT( !Notpredicate(origin) );
+
+    // center is inside
+    CPPUNIT_ASSERT( !Notpredicate(center) );
+
+    // corner is inside
+    CPPUNIT_ASSERT( !Notpredicate(corner) );
+
+    // outside is outside
+    CPPUNIT_ASSERT( Notpredicate(outside) );
+    domain.setCondition(0, BoundaryConditions::Wrap);
+  }
+
+  // set BCs back to default Ignore
+  domain.setConditions(
+      BoundaryConditions::Conditions_t(3, BoundaryConditions::Ignore)
+  );
+	// check on not void
+#ifndef NDEBUG
+  std::cout << "The following Assertion is intended and does not represent a failure of the test." << std::endl;
+  CPPUNIT_ASSERT_THROW( Notpredicate2( Vector(-2.,0.,0.)), Assert::AssertionFailure );
+#else
+  CPPUNIT_ASSERT( !Notpredicate2( Vector(-2.,0.,0.)) );
+#endif
+  for (double i = 0; i < 5.; ++i) {
+    CPPUNIT_ASSERT( Notpredicate2( Vector(i, 0., 0.)) );
+    CPPUNIT_ASSERT( Notpredicate2( Vector(i, 1., 0.)) );
+#ifndef NDEBUG
+  std::cout << "The following Assertion is intended and does not represent a failure of the test." << std::endl;
+  CPPUNIT_ASSERT_THROW( Notpredicate2( Vector(i, -1., 0.)), Assert::AssertionFailure );
+#else
+  CPPUNIT_ASSERT( Notpredicate2( Vector(i, -1., 0.)) );
+#endif
+    CPPUNIT_ASSERT( Notpredicate2( Vector(i, 0., 1.)) );
+#ifndef NDEBUG
+  std::cout << "The following Assertion is intended and does not represent a failure of the test." << std::endl;
+  CPPUNIT_ASSERT_THROW( Notpredicate2( Vector(i, 0., -1.)), Assert::AssertionFailure );
+#else
+  CPPUNIT_ASSERT( Notpredicate2( Vector(i, 0., -1.)) );
+#endif
+  }
+  CPPUNIT_ASSERT( !Notpredicate2( Vector(5.,1.,0.)) );
+#ifndef NDEBUG
+  std::cout << "The following Assertion is intended and does not represent a failure of the test." << std::endl;
+  CPPUNIT_ASSERT_THROW( Notpredicate2( Vector(5.,-1.,0.)), Assert::AssertionFailure );
+#else
+  CPPUNIT_ASSERT( !Notpredicate2( Vector(5.,-1.,0.)) );
+#endif
+  CPPUNIT_ASSERT( !Notpredicate2( Vector(5.,0.,1.)) );
+#ifndef NDEBUG
+  std::cout << "The following Assertion is intended and does not represent a failure of the test." << std::endl;
+  CPPUNIT_ASSERT_THROW( Notpredicate2( Vector(5.,0.,-1.)), Assert::AssertionFailure );
+#else
+  CPPUNIT_ASSERT( !Notpredicate2( Vector(5.,0.,-1.)) );
+#endif
+  CPPUNIT_ASSERT( !Notpredicate2( Vector(6.,0.,0.)) );
+}
Index: src/Filling/unittests/Ops_FillPredicateUnitTest.hpp
===================================================================
--- src/Filling/unittests/Ops_FillPredicateUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/unittests/Ops_FillPredicateUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,50 @@
+/*
+ * Ops_FillPredicateUnitTest.hpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+#ifndef OPS_FILLPREDICATEUNITTEST_HPP_
+#define OPS_FILLPREDICATEUNITTEST_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <cppunit/extensions/HelperMacros.h>
+
+#include <vector>
+
+class atom;
+class Box;
+class RealSpaceMatrix;
+class FillPredicate;
+
+/********************************************** Test classes **************************************/
+
+class Ops_FillPredicateTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( Ops_FillPredicateTest) ;
+    CPPUNIT_TEST ( AndTest );
+    CPPUNIT_TEST ( OrTest );
+    CPPUNIT_TEST ( NotTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+      void AndTest();
+      void OrTest();
+      void NotTest();
+
+private:
+      std::vector<atom *> atoms;
+
+      FillPredicate *Voidpredicate;
+      FillPredicate *Domainpredicate;
+};
+
+#endif /* OPS_FILLPREDICATEUNITTEST_HPP_ */
Index: src/Fragmentation/Fragmentation.cpp
===================================================================
--- src/Fragmentation/Fragmentation.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Fragmentation/Fragmentation.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -27,4 +27,5 @@
 #include "Atom/atom.hpp"
 #include "Bond/bond.hpp"
+#include "Descriptors/MoleculeDescriptor.hpp"
 #include "Element/element.hpp"
 #include "Element/periodentafel.hpp"
Index: src/Graph/DepthFirstSearchAnalysis.cpp
===================================================================
--- src/Graph/DepthFirstSearchAnalysis.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Graph/DepthFirstSearchAnalysis.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -32,4 +32,5 @@
 #include "CodePatterns/Verbose.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
+#include "Descriptors/MoleculeDescriptor.hpp"
 #include "molecule.hpp"
 #include "MoleculeLeafClass.hpp"
Index: src/IdPool_impl.hpp
===================================================================
--- src/IdPool_impl.hpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/IdPool_impl.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -96,5 +96,5 @@
     return;
   }
-  LOG(1, "STATUS: Defragmenting id pool.");
+  LOG(3, "DEBUG: Defragmenting id pool.");
   for(typename IdPool_t::iterator iter = pool.begin();iter!=pool.end();) {
     // see if this range is adjacent to the next one
Index: src/LinkedCell/Makefile.am
===================================================================
--- src/LinkedCell/Makefile.am	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/LinkedCell/Makefile.am	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -20,4 +20,5 @@
   LinkedCell/LinkedCell_Model.hpp \
   LinkedCell/LinkedCell_Model_changeModel.hpp \
+  LinkedCell/LinkedCell_Model_inline.hpp \
   LinkedCell/LinkedCell_Model_LinkedCellArrayCache.hpp \
   LinkedCell/LinkedCell_Model_Update.hpp \
Index: src/LinkedCell/unittests/Makefile.am
===================================================================
--- src/LinkedCell/unittests/Makefile.am	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/LinkedCell/unittests/Makefile.am	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -53,10 +53,10 @@
 	../LinkedCell/unittests/LinkedCell_ControllerUnitTest.hpp \
 	../LinkedCell/unittests/defs.hpp \
-	../LinkedCell/unittests/stubs/AtomStub.cpp \
+	stubs/AtomStub.cpp \
 	../LinkedCell/unittests/stubs/AtomObserverStub.cpp \
 	../LinkedCell/unittests/stubs/ObserverBoxStub.cpp \
 	../LinkedCell/unittests/stubs/TesselPointStub.cpp \
-	../LinkedCell/unittests/stubs/WorldStub.cpp \
 	../LinkedCell/unittests/stubs/WorldTimeStub.cpp \
+	stubs/WorldStub.cpp \
 	../LinkedCell/PointCloudAdaptor.hpp \
 	../Box_BoundaryConditions.cpp \
Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Makefile.am	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -13,4 +13,5 @@
 include Atom/Makefile.am
 include Element/Makefile.am
+include Filling/Makefile.am
 include Fragmentation/Makefile.am
 include Graph/Makefile.am
@@ -124,4 +125,6 @@
 
 TESSELATIONSOURCE = \
+  Tesselation/ApproximateShapeArea.cpp \
+  Tesselation/ApproximateShapeVolume.cpp \
   Tesselation/boundary.cpp \
   Tesselation/BoundaryLineSet.cpp \
@@ -136,4 +139,6 @@
   
 TESSELATIONHEADER = \
+  Tesselation/ApproximateShapeArea.hpp \
+  Tesselation/ApproximateShapeVolume.hpp \
   Tesselation/boundary.hpp \
   Tesselation/BoundaryLineSet.hpp \
@@ -154,4 +159,5 @@
   ${THERMOSTATSOURCE} \
   ${TESSELATIONSOURCE} \
+  AtomIdSet.cpp \
   Box.cpp \
   Box_BoundaryConditions.cpp \
@@ -175,4 +181,5 @@
   ${THERMOSTATHEADER} \
   ${TESSELATIONHEADER} \
+  AtomIdSet.hpp \
   Box.hpp \
   Box_BoundaryConditions.hpp \
Index: src/Shapes/BaseShapes.cpp
===================================================================
--- src/Shapes/BaseShapes.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Shapes/BaseShapes.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -37,13 +37,13 @@
 #include <algorithm>
 
-bool Sphere_impl::isInside(const Vector &point){
-  return point.NormSquared()<=1;
-}
-
-bool Sphere_impl::isOnSurface(const Vector &point){
-  return fabs(point.NormSquared()-1)<MYEPSILON;
-}
-
-Vector Sphere_impl::getNormal(const Vector &point) throw(NotOnSurfaceException){
+bool Sphere_impl::isInside(const Vector &point) const{
+  return point.NormSquared()<=1.;
+}
+
+bool Sphere_impl::isOnSurface(const Vector &point) const{
+  return fabs(point.NormSquared()-1.)<MYEPSILON;
+}
+
+Vector Sphere_impl::getNormal(const Vector &point) const throw(NotOnSurfaceException){
   if(!isOnSurface(point)){
     throw NotOnSurfaceException() << ShapeVector(&point);
@@ -52,5 +52,26 @@
 }
 
-LineSegmentSet Sphere_impl::getLineIntersections(const Line &line){
+Vector Sphere_impl::getCenter() const
+{
+  return Vector(0.,0.,0.);
+}
+
+double Sphere_impl::getRadius() const
+{
+  return 1.;
+}
+
+double Sphere_impl::getVolume() const
+{
+	return (4./3.)*M_PI; // 4/3 pi r^3
+}
+
+double Sphere_impl::getSurfaceArea() const
+{
+	return 2.*M_PI;	// 2 pi r^2
+}
+
+
+LineSegmentSet Sphere_impl::getLineIntersections(const Line &line) const{
   LineSegmentSet res(line);
   std::vector<Vector> intersections = line.getSphereIntersections();
@@ -61,6 +82,11 @@
 }
 
-std::string Sphere_impl::toString(){
+std::string Sphere_impl::toString() const{
   return "Sphere()";
+}
+
+enum ShapeType Sphere_impl::getType() const
+{
+	return SphereType;
 }
 
@@ -115,4 +141,9 @@
 }
 
+std::vector<Vector> Sphere_impl::getHomogeneousPointsInVolume(const size_t N) const {
+	ASSERT(0,
+			"Sphere_impl::getHomogeneousPointsInVolume() - not implemented.");
+	return std::vector<Vector>();
+}
 
 Shape Sphere(){
@@ -129,9 +160,9 @@
 }
 
-bool Cuboid_impl::isInside(const Vector &point){
+bool Cuboid_impl::isInside(const Vector &point) const{
   return (point[0]>=0 && point[0]<=1) && (point[1]>=0 && point[1]<=1) && (point[2]>=0 && point[2]<=1);
 }
 
-bool Cuboid_impl::isOnSurface(const Vector &point){
+bool Cuboid_impl::isOnSurface(const Vector &point) const{
   bool retVal = isInside(point);
   // test all borders of the cuboid
@@ -144,5 +175,5 @@
 }
 
-Vector Cuboid_impl::getNormal(const Vector &point) throw(NotOnSurfaceException){
+Vector Cuboid_impl::getNormal(const Vector &point) const throw(NotOnSurfaceException){
   if(!isOnSurface(point)){
     throw NotOnSurfaceException() << ShapeVector(&point);
@@ -162,5 +193,26 @@
 }
 
-LineSegmentSet Cuboid_impl::getLineIntersections(const Line &line){
+
+Vector Cuboid_impl::getCenter() const
+{
+  return Vector(0.5,0.5,0.5);
+}
+
+double Cuboid_impl::getRadius() const
+{
+  return .5;
+}
+
+double Cuboid_impl::getVolume() const
+{
+	return 1.; // l^3
+}
+
+double Cuboid_impl::getSurfaceArea() const
+{
+	return 6.;	// 6 * l^2
+}
+
+LineSegmentSet Cuboid_impl::getLineIntersections(const Line &line) const{
   LineSegmentSet res(line);
   // get the intersection on each of the six faces
@@ -192,6 +244,11 @@
 }
 
-std::string Cuboid_impl::toString(){
+std::string Cuboid_impl::toString() const{
   return "Cuboid()";
+}
+
+enum ShapeType Cuboid_impl::getType() const
+{
+	return CuboidType;
 }
 
@@ -203,4 +260,10 @@
   ASSERT(false, "Cuboid_impl::getHomogeneousPointsOnSurface() not implemented yet");
   return PointsOnSurface;
+}
+
+std::vector<Vector> Cuboid_impl::getHomogeneousPointsInVolume(const size_t N) const {
+	ASSERT(0,
+			"Cuboid_impl::getHomogeneousPointsInVolume() - not implemented.");
+	return std::vector<Vector>();
 }
 
Index: src/Shapes/BaseShapes_impl.hpp
===================================================================
--- src/Shapes/BaseShapes_impl.hpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Shapes/BaseShapes_impl.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -20,21 +20,34 @@
 #include "Shapes/Shape_impl.hpp"
 #include "Shapes/ShapeExceptions.hpp"
+#include "Shapes/ShapeType.hpp"
 
 class Sphere_impl : public Shape_impl {
-  virtual bool isInside(const Vector &point);
-  virtual bool isOnSurface(const Vector &point);
-  virtual Vector getNormal(const Vector &point) throw(NotOnSurfaceException);
-  virtual LineSegmentSet getLineIntersections(const Line&);
-  virtual std::string toString();
+  virtual bool isInside(const Vector &point) const;
+  virtual bool isOnSurface(const Vector &point) const;
+  virtual Vector getNormal(const Vector &point) const throw(NotOnSurfaceException);
+  virtual Vector getCenter() const;
+  virtual double getRadius() const;
+  virtual double getVolume() const;
+  virtual double getSurfaceArea() const;
+  virtual LineSegmentSet getLineIntersections(const Line&) const;
+  virtual std::string toString() const;
+  virtual enum ShapeType getType() const;
   virtual std::vector<Vector> getHomogeneousPointsOnSurface(const size_t N) const;
+  virtual std::vector<Vector> getHomogeneousPointsInVolume(const size_t N) const;
 };
 
 class Cuboid_impl : public Shape_impl {
-  virtual bool isInside(const Vector &point);
-  virtual bool isOnSurface(const Vector &point);
-  virtual Vector getNormal(const Vector &point) throw(NotOnSurfaceException);
-  virtual LineSegmentSet getLineIntersections(const Line&);
-  virtual std::string toString();
+  virtual bool isInside(const Vector &point) const;
+  virtual bool isOnSurface(const Vector &point) const;
+  virtual Vector getNormal(const Vector &point) const throw(NotOnSurfaceException);
+  virtual Vector getCenter() const;
+  virtual double getRadius() const;
+  virtual double getVolume() const;
+  virtual double getSurfaceArea() const;
+  virtual LineSegmentSet getLineIntersections(const Line&) const;
+  virtual std::string toString() const;
+  virtual enum ShapeType getType() const;
   virtual std::vector<Vector> getHomogeneousPointsOnSurface(const size_t N) const;
+  virtual std::vector<Vector> getHomogeneousPointsInVolume(const size_t N) const;
 };
 
